Last Comment Bug 734517 - GC: missing barriers in InitExnPrivates
: GC: missing barriers in InitExnPrivates
Status: RESOLVED FIXED
:
Product: Core
Classification: Components
Component: JavaScript Engine (show other bugs)
: Trunk
: All All
: -- normal (vote)
: mozilla14
Assigned To: Terrence Cole [:terrence]
:
Mentors:
Depends on:
Blocks: 673454
  Show dependency treegraph
 
Reported: 2012-03-09 15:05 PST by Terrence Cole [:terrence]
Modified: 2012-03-15 08:05 PDT (History)
3 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments
v0 (4.79 KB, patch)
2012-03-12 14:00 PDT, Terrence Cole [:terrence]
wmccloskey: review+
Details | Diff | Splinter Review

Description Terrence Cole [:terrence] 2012-03-09 15:05:01 PST
InitExnPrivate needs to trigger barriers when copying out to the heap, but not when copying data into the on-stack vector.
Comment 1 Terrence Cole [:terrence] 2012-03-12 14:00:56 PDT
Created attachment 605095 [details] [diff] [review]
v0

I verified that this patch fixes half the failures I am experiencing with my write buffer.
Comment 2 Bill McCloskey (:billm) 2012-03-12 14:08:38 PDT
Comment on attachment 605095 [details] [diff] [review]
v0

Review of attachment 605095 [details] [diff] [review]:
-----------------------------------------------------------------

::: js/src/jsexn.cpp
@@ +122,5 @@
> +typedef JSStackTraceElemImpl<HeapPtrString> JSStackTraceElem;
> +typedef JSStackTraceElemImpl<JSString *>    JSStackTraceStackElem;
> +
> +static void
> +copyTraceElemToHeap(JSStackTraceElem *dst, JSStackTraceStackElem *src)

Can you just put the code directly in the loop? If it's in a function, it's possible people will call it without realizing that it does init() rather than set().

Also, in general, functions like this should start with an uppercase letter.
Comment 3 Terrence Cole [:terrence] 2012-03-14 10:52:02 PDT
http://hg.mozilla.org/integration/mozilla-inbound/rev/da22cf5a850f
Comment 4 Terrence Cole [:terrence] 2012-03-14 10:52:55 PDT
Thanks for the help, bugzilla, but no.
Comment 5 Marco Bonardo [::mak] (Away 6-20 Aug) 2012-03-15 08:05:08 PDT
https://hg.mozilla.org/mozilla-central/rev/da22cf5a850f

Note You need to log in before you can comment on or make changes to this bug.